#ifndef SS80_H_
#define SS80_H_
#include "db_utils.h"
int SS80_char(unsigned char ch, unsigned char atn, unsigned char reset);
void SS80_init(void);
void SS80_cmd_send_status(void);
int SS80_cmd_seek(void);
int SS80_cmd_buffered_read(void);
int SS80_cmd_buffered_write(void);
void SS80_cmd_dsj(void);
void SS80_cmd_clear(void);
void SS80_increment(void);
void SS80_Test(void);
void SS80_error_return(void);
void SS80_cmd_send_status(void);
void SS80_cmd_describe(void);
int Write_sector(void);

BYTE SS80_do_command(BYTE ch);
BYTE SS80_exec_command(BYTE ch);

int Write_sector();

extern unsigned volatile int SS80_state;
extern char buffer[256];
//
// Transaction state-machine states
//
#define SS80_TRAN_IDLE		0
#define SS80_TRAN_COMMAND	1
#define SS80_TRAN_EXECUTION 2
#define SS80_TRAN_REPORT	3
#define SS80_TRAN_AMIGO_CLEAR 4
#define SS80_TRANSPARENT 	5

// command State-machine states
//
#define SS80_START 		0
#define SS80_000		10
#define SS80_002		20
#define SS80_00D		700
#define SS80_010_1		1001
#define SS80_010_2		1002
#define SS80_010_3		1003
#define SS80_010_4		1004
#define SS80_010_5		1005
#define SS80_010_6		1006
#define SS80_018_1		1801
#define SS80_018_2		1802
#define SS80_018_3		1803
#define SS80_018_4		1804
#define SS80_034		3400
#define SS80_035			3500
#define SS80_037_1		3701
#define SS80_037_2		3702
#define SS80_068_L			6800
#define SS80_068_T			6850
#define SS80_068_STATUS	6801
#define SS80_068_SEEK		6802
#define SS80_068_SEEK_1	6811
#define SS80_068_SEEK_2	6812
#define SS80_068_SEEK_3	6813
#define SS80_068_SEEK_4	6814
#define SS80_068_WAKEUP	6820
#define SS80_06A			6900
#define SS80_06A_READ		6901
#define SS80_06A_READ_1	6902
#define SS80_06A_READ_2	6903
#define SS80_070_T			7000
#define SS80_070_L			7010
#define SS80_072_L			7210

#define SS80_END			9999

// Returned command codes
#define SS80_CMD_DESCRIBE		1
#define SS80_CMD_SEND_STATUS	2
#define SS80_CMD_BUFFERED_READ	3
#define SS80_CMD_DSJ			4
#define SS80_CMD_BUFFERED_WRITE 5
#define SS80_CMD_WAKEUP 		6
#define SS80_CMD_CLEAR			7
#define SS80_CMD_NOP			8



typedef struct {
int LIFid;
char label[6];
int dirstarthi;
int dirstartlo;
int s3000;
int dummy;
int dirlenhi;
int dirlenlo;
int version;
} VolumeLabelType;


typedef struct {
	char filename[10];
	int filetype;
	int startaddhi;
	int startaddlo;
	int lengthhi;
	int lengthlo;
	char createtime[6];	// BCD digits
	int volnumber;
	int implementationhi;
	int implementationlo;
} DirEntryType;

typedef struct {
	char unit;
	char cyl;
	char head;
	char sector;
} DiskType;

extern VolumeLabelType vl;
extern DirEntryType de;
extern DiskType Disk;

extern void DumpData(unsigned char *Ptr,int length);

#endif